import Foundation

struct Language: Equatable, CustomStringConvertible {
    let isoCode: String
    let displayName: String

    var description: String {
        return displayName
    }

    static let all = [
        Language(isoCode: "ab", displayName: "Abkhazian"),
        Language(isoCode: "aa", displayName: "Afar"),
        Language(isoCode: "af", displayName: "Afrikaans"),
        Language(isoCode: "ak", displayName: "Akan"),
        Language(isoCode: "sq", displayName: "Albanian"),
        Language(isoCode: "am", displayName: "Amharic"),
        Language(isoCode: "ar", displayName: "Arabic"),
        Language(isoCode: "an", displayName: "Aragonese"),
        Language(isoCode: "hy", displayName: "Armenian"),
        Language(isoCode: "as", displayName: "Assamese"),
        Language(isoCode: "av", displayName: "Avaric"),
        Language(isoCode: "ae", displayName: "Avestan"),
        Language(isoCode: "ay", displayName: "Aymara"),
        Language(isoCode: "az", displayName: "Azerbaijani"),
        Language(isoCode: "bm", displayName: "Bambara"),
        Language(isoCode: "ba", displayName: "Bashkir"),
        Language(isoCode: "eu", displayName: "Basque"),
        Language(isoCode: "be", displayName: "Belarusian"),
        Language(isoCode: "bn", displayName: "Bengali"),
        Language(isoCode: "bh", displayName: "Bihari languages"),
        Language(isoCode: "bi", displayName: "Bislama"),
        Language(isoCode: "bs", displayName: "Bosnian"),
        Language(isoCode: "br", displayName: "Breton"),
        Language(isoCode: "bg", displayName: "Bulgarian"),
        Language(isoCode: "my", displayName: "Burmese"),
        Language(isoCode: "ca", displayName: "Catalan; Valencian"),
        Language(isoCode: "km", displayName: "Central Khmer"),
        Language(isoCode: "ch", displayName: "Chamorro"),
        Language(isoCode: "ce", displayName: "Chechen"),
        Language(isoCode: "ny", displayName: "Chichewa; Chewa; Nyanja"),
        Language(isoCode: "zh", displayName: "Chinese"),
        Language(isoCode: "cu", displayName: "Church Slavic; Old Slavonic; Church Slavonic; Old Bulgarian; Old Church Slavonic"),
        Language(isoCode: "cv", displayName: "Chuvash"),
        Language(isoCode: "kw", displayName: "Cornish"),
        Language(isoCode: "co", displayName: "Corsican"),
        Language(isoCode: "cr", displayName: "Cree"),
        Language(isoCode: "hr", displayName: "Croatian"),
        Language(isoCode: "cs", displayName: "Czech"),
        Language(isoCode: "da", displayName: "Danish"),
        Language(isoCode: "dv", displayName: "Dhivehi; Dhivehi; Maldivian"),
        Language(isoCode: "nl", displayName: "Dutch; Flemish"),
        Language(isoCode: "dz", displayName: "Dzongkha"),
        Language(isoCode: "en", displayName: "English"),
        Language(isoCode: "eo", displayName: "Esperanto"),
        Language(isoCode: "et", displayName: "Estonian"),
        Language(isoCode: "ee", displayName: "Ewe"),
        Language(isoCode: "fo", displayName: "Faroese"),
        Language(isoCode: "fj", displayName: "Fijian"),
        Language(isoCode: "fi", displayName: "Finnish"),
        Language(isoCode: "fr", displayName: "French"),
        Language(isoCode: "ff", displayName: "Fulah"),
        Language(isoCode: "gd", displayName: "Gaelic; Scottish Gaelic"),
        Language(isoCode: "gl", displayName: "Galician"),
        Language(isoCode: "lg", displayName: "Ganda"),
        Language(isoCode: "ka", displayName: "Georgian"),
        Language(isoCode: "de", displayName: "German"),
        Language(isoCode: "gn", displayName: "Guarani"),
        Language(isoCode: "gu", displayName: "Gujarati"),
        Language(isoCode: "ht", displayName: "Haitian; Haitian Creole"),
        Language(isoCode: "ha", displayName: "Hausa"),
        Language(isoCode: "he", displayName: "Hebrew"),
        Language(isoCode: "hz", displayName: "Herero"),
        Language(isoCode: "hi", displayName: "Hindi"),
        Language(isoCode: "ho", displayName: "Hiri Motu"),
        Language(isoCode: "hu", displayName: "Hungarian"),
        Language(isoCode: "is", displayName: "Icelandic"),
        Language(isoCode: "io", displayName: "Ido"),
        Language(isoCode: "ig", displayName: "Igbo"),
        Language(isoCode: "id", displayName: "Indonesian"),
        Language(isoCode: "ia", displayName: "Interlingua (International Auxiliary Language Association)"),
        Language(isoCode: "ie", displayName: "Interlingue; Occidental"),
        Language(isoCode: "iu", displayName: "Inuktitut"),
        Language(isoCode: "ik", displayName: "Inupiaq"),
        Language(isoCode: "ga", displayName: "Irish"),
        Language(isoCode: "it", displayName: "Italian"),
        Language(isoCode: "ja", displayName: "Japanese"),
        Language(isoCode: "jv", displayName: "Javanese"),
        Language(isoCode: "kl", displayName: "Kalaallisut; Greenlandic"),
        Language(isoCode: "kn", displayName: "Kannada"),
        Language(isoCode: "kr", displayName: "Kanuri"),
        Language(isoCode: "ks", displayName: "Kashmiri"),
        Language(isoCode: "kk", displayName: "Kazakh"),
        Language(isoCode: "ki", displayName: "Kikuyu; Gikuyu"),
        Language(isoCode: "rw", displayName: "Kinyarwanda"),
        Language(isoCode: "ky", displayName: "Kirghiz; Kyrgyz"),
        Language(isoCode: "kv", displayName: "Komi"),
        Language(isoCode: "kg", displayName: "Kongo"),
        Language(isoCode: "ko", displayName: "Korean"),
        Language(isoCode: "kj", displayName: "Kuanyama; Kwanyama"),
        Language(isoCode: "ku", displayName: "Kurdish"),
        Language(isoCode: "lo", displayName: "Lao"),
        Language(isoCode: "la", displayName: "Latin"),
        Language(isoCode: "lv", displayName: "Latvian"),
        Language(isoCode: "li", displayName: "Limburgan; Limburger; Limburgish"),
        Language(isoCode: "ln", displayName: "Lingala"),
        Language(isoCode: "lt", displayName: "Lithuanian"),
        Language(isoCode: "lu", displayName: "Luba-Katanga"),
        Language(isoCode: "lb", displayName: "Luxembourgish; Letzeburgesch"),
        Language(isoCode: "mk", displayName: "Macedonian"),
        Language(isoCode: "mg", displayName: "Malagasy"),
        Language(isoCode: "ms", displayName: "Malay"),
        Language(isoCode: "ml", displayName: "Malayalam"),
        Language(isoCode: "mt", displayName: "Maltese"),
        Language(isoCode: "gv", displayName: "Manx"),
        Language(isoCode: "mi", displayName: "Maori"),
        Language(isoCode: "mr", displayName: "Marathi"),
        Language(isoCode: "mh", displayName: "Marshallese"),
        Language(isoCode: "el", displayName: "Modern Greek (1453–)"),
        Language(isoCode: "mn", displayName: "Mongolian"),
        Language(isoCode: "na", displayName: "Nauru"),
        Language(isoCode: "nv", displayName: "Navajo; Navaho"),
        Language(isoCode: "ng", displayName: "Ndonga"),
        Language(isoCode: "ne", displayName: "Nepali"),
        Language(isoCode: "nd", displayName: "North Ndebele"),
        Language(isoCode: "se", displayName: "Northern Sami"),
        Language(isoCode: "no", displayName: "Norwegian"),
        Language(isoCode: "nb", displayName: "Norwegian Bokmål"),
        Language(isoCode: "nn", displayName: "Norwegian Nynorsk"),
        Language(isoCode: "oc", displayName: "Occitan (post 1500)"),
        Language(isoCode: "oj", displayName: "Ojibwa"),
        Language(isoCode: "or", displayName: "Oriya"),
        Language(isoCode: "om", displayName: "Oromo"),
        Language(isoCode: "os", displayName: "Ossetian; Ossetic"),
        Language(isoCode: "pi", displayName: "Pali"),
        Language(isoCode: "pa", displayName: "Panjabi; Punjabi"),
        Language(isoCode: "fa", displayName: "Persian"),
        Language(isoCode: "pl", displayName: "Polish"),
        Language(isoCode: "pt", displayName: "Portuguese"),
        Language(isoCode: "ps", displayName: "Pushto; Pashto"),
        Language(isoCode: "qu", displayName: "Quechua"),
        Language(isoCode: "ro", displayName: "Romanian; Moldavian; Moldovan"),
        Language(isoCode: "rm", displayName: "Romansh"),
        Language(isoCode: "rn", displayName: "Rundi"),
        Language(isoCode: "ru", displayName: "Russian"),
        Language(isoCode: "sm", displayName: "Samoan"),
        Language(isoCode: "sg", displayName: "Sango"),
        Language(isoCode: "sa", displayName: "Sanskrit"),
        Language(isoCode: "sc", displayName: "Sardinian"),
        Language(isoCode: "sr", displayName: "Serbian"),
        Language(isoCode: "sn", displayName: "Shona"),
        Language(isoCode: "ii", displayName: "Sichuan Yi; Nuosu"),
        Language(isoCode: "sd", displayName: "Sindhi"),
        Language(isoCode: "si", displayName: "Sinhala; Sinhalese"),
        Language(isoCode: "sk", displayName: "Slovak"),
        Language(isoCode: "sl", displayName: "Slovenian"),
        Language(isoCode: "so", displayName: "Somali"),
        Language(isoCode: "nr", displayName: "South Ndebele"),
        Language(isoCode: "st", displayName: "Southern Sotho"),
        Language(isoCode: "es", displayName: "Spanish; Castilian"),
        Language(isoCode: "su", displayName: "Sundanese"),
        Language(isoCode: "sw", displayName: "Swahili"),
        Language(isoCode: "ss", displayName: "Swati"),
        Language(isoCode: "sv", displayName: "Swedish"),
        Language(isoCode: "tl", displayName: "Tagalog"),
        Language(isoCode: "ty", displayName: "Tahitian"),
        Language(isoCode: "tg", displayName: "Tajik"),
        Language(isoCode: "ta", displayName: "Tamil"),
        Language(isoCode: "tt", displayName: "Tatar"),
        Language(isoCode: "te", displayName: "Telugu"),
        Language(isoCode: "th", displayName: "Thai"),
        Language(isoCode: "bo", displayName: "Tibetan"),
        Language(isoCode: "ti", displayName: "Tigrinya"),
        Language(isoCode: "to", displayName: "Tonga (Tonga Islands)"),
        Language(isoCode: "ts", displayName: "Tsonga"),
        Language(isoCode: "tn", displayName: "Tswana"),
        Language(isoCode: "tr", displayName: "Turkish"),
        Language(isoCode: "tk", displayName: "Turkmen"),
        Language(isoCode: "tw", displayName: "Twi"),
        Language(isoCode: "ug", displayName: "Uighur; Uyghur"),
        Language(isoCode: "uk", displayName: "Ukrainian"),
        Language(isoCode: "ur", displayName: "Urdu"),
        Language(isoCode: "uz", displayName: "Uzbek"),
        Language(isoCode: "ve", displayName: "Venda"),
        Language(isoCode: "vi", displayName: "Vietnamese"),
        Language(isoCode: "vo", displayName: "Volapük"),
        Language(isoCode: "wa", displayName: "Walloon"),
        Language(isoCode: "cy", displayName: "Welsh"),
        Language(isoCode: "fy", displayName: "Western Frisian"),
        Language(isoCode: "wo", displayName: "Wolof"),
        Language(isoCode: "xh", displayName: "Xhosa"),
        Language(isoCode: "yi", displayName: "Yiddish"),
        Language(isoCode: "yo", displayName: "Yoruba"),
        Language(isoCode: "za", displayName: "Zhuang; Chuang")
    ]

    static let byIsoCode = Language.all.reduce(into: [String: Language]()) { $0[$1.isoCode] = $1 }
}
